PROCEDURE pt_help
PARAMETERS pr_name
PRIVATE pr_name, v_name, m_name, po_name, seek_str
PRIVATE m_choice, m_ch, cur_buff, cur_curs, cur_exact
PRIVATE cur_win, m_prmpt, i, ar_help, max_call, m_wind

*  Copyright (c) 1992 Performance Dynamics Associates
*  Stripped-down version of Power Tools Help System

***  set up our environment

ON KEY LABEL F1 DO hp_mess WITH 1

cur_curs = set('cursor') = 'ON'  &&  current cursor state
SET CURSOR off

cur_exact = set('exact') = 'ON'  &&  current set exact state
SET EXACT OFF

cur_buff = alias()            &&  current work area
cur_win = window()            &&  current window

IF type('help_dev') = 'U'     &&  if no help_dev memvar
  help_dev = .f.              &&  only show help
ENDIF

IF readkey() = 512            &&  we are in a read
  v_name = varread()          &&  the current GET
  m_name = ''
  po_name = ''
  menu_val = ''
  m_ch = .f.   
ELSE                          &&  no read?
  v_name = ''                 &&  no value for get
  m_name = menu()             &&  the current menu name
  po_name = popup()           &&  the current popup name
  menu_val = prompt()         &&  the current menu value
  m_ch = .f.                  &&  looking for menu help?
ENDIF

***  pad to the proper dimension

pr_name = left(pr_name + space(10),10)
v_name = left(v_name + space(10),10)
m_name = left(m_name + space(10),10)
po_name = left(po_name + space(10),10)
menu_val = left(menu_val + space(10),10)

***  build our search string

seek_str = pr_name+ v_name + m_name + po_name

SELECT help                   &&  database already open
SEEK seek_str

IF found() .and. menu_ch      &&  we have detailed menu help
  seek_str = seek_str + menu_val    &&  add the prompt value
  SEEK seek_str               &&  seek again
  m_ch = .t.                  &&  change our flag
ENDIF

IF .not. help_dev             &&  if not in help development
  DO hp_pop                   &&  show the help
ELSE                          &&  if in help development
  DO hp_dev                   &&  develop the help
ENDIF

IF isblank(cur_buff)
  SELECT select()
ELSE
  SELECT(cur_buff)
ENDIF

IF cur_curs                   &&  reset cursor
  SET CURSOR on
ENDIF

IF cur_exact                  &&  reset exact
  SET EXACT ON
ENDIF

IF isblank(cur_win)           &&  screen was active
  ACTIVATE SCREEN
ENDIF

ON KEY LABEL F1 DO pt_help WITH program()  && reset help

RETURN

******

PROCEDURE hp_pop

IF found()            &&  if help record found
  junk = memo_pop(ul_row,ul_col,lr_row,lr_col,'help_mess')
ELSE
  junk = poptalk('No help is available for this situation.',3)
ENDIF

RETURN

******

PROCEDURE hp_dev

***  Here is where we develop our help screens

IF .not. found()              &&  no help in file
  ON KEY LABEL F1 DO hp_mess WITH 2

  m_choice = yesno('No help is currently available '+;
                   'for the current program situation.  '+;
                   'Do you want to create a new help '+;
                   'screen?')

  IF m_choice                 &&  we want to create help

***  if there is an active menu or popup and there is no
***  READ going on find out if we are going to have help
***  on individual menu item.

    ON KEY LABEL F1 DO hp_mess WITH 3

    IF .not. m_ch .and. isblank(v_name) .and. ;
       (.not. isblank(m_name) .or. .not. isblank(po_name))
      m_ch = yesno('You are creating the first help '+;
                   'screen for a menu or a popup.  '+;
                   'You can have either a single help '+;
                   'screen for the entire menu or '+;
                   'separate help screens for each '+;
                   'menu option.  Do you want help '+;
                   'on each menu choice?')
    ENDIF

***  now load the results into the new help record.

    APPEND BLANK              &&  add a new help record

    REPLACE proc_name WITH pr_name, vari_name WITH v_name,;
            menu_name WITH m_name, popup_name WITH po_name,;
            menu_value WITH menu_val, menu_ch WITH m_ch,;
            ul_row WITH 0, ul_col WITH 0, lr_row WITH 24,;
            lr_col WITH 79

    DO hp_dev1                &&  go to help editing
  ENDIF

ELSE                          &&  the help record is there
  DO hp_dev1
ENDIF

RETURN

********

PROCEDURE hp_dev1
PRIVATE hp_choice, mul_row, mul_col, mlr_row, mlr_col

***  load the window coordinates from the help record

mul_row = ul_row
mul_col = ul_col
mlr_row = lr_row
mlr_col = lr_col

DEFINE WINDOW hp_dev1 FROM 01,01 TO 14,24 DOUBLE
ACTIVATE WINDOW hp_dev1

DO WHILE .t.
  ON KEY LABEL F1 DO hp_mess WITH 4

  @ 00,03 SAY 'Help Development'
  @ 02,03 SAY '1 - Edit screen'
  @ 03,03 SAY '2 - Size Screen'
  @ 04,03 SAY '3 - Move screen'
  @ 05,03 SAY '4 - Show screen'
  @ 06,03 SAY '6 - Delete screen'
  @ 07,03 SAY '0 - Save screen'
  @ 11,03 SAY 'Press F1 for Help'
  @ 09,03 SAY 'Your choice...'

  SET CONSOLE OFF
  hp_choice = 9
  WAIT '' TO hp_choice
  SET CONSOLE ON

  IF type('hp_choice') # 'C'  &&  trap for escape key
    LOOP
  ENDIF

  DEACTIVATE WINDOW hp_dev1

  DO CASE

    CASE hp_choice = '1'      &&  edit the help record
      DO hp_edit

    CASE hp_choice = '2'      &&  size the help window
      DO hp_size

    CASE hp_choice = '3'      &&  move the help window
      DO hp_move

    CASE hp_choice = '4'      &&  show the help screen
      junk = memo_pop(mul_row,mul_col,mlr_row,mlr_col,;
                      'help_mess')

    CASE hp_choice = '6'      &&  delete the help record

      IF yesno('Delete current help record?')
        DELETE
        PACK
        EXIT
      ENDIF

    CASE hp_choice = '0'      &&  save the record

***  replace the window coordinates with the current ones

      REPLACE ul_row WITH mul_row, ul_col WITH mul_col,;
              lr_row WITH mlr_row, lr_col WITH mlr_col
      EXIT

    CASE isblank(hp_choice)

      DO hp_mess WITH 4

    OTHERWISE
      ?? chr(7)

  ENDCASE

  ACTIVATE WINDOW hp_dev1

ENDDO

RELEASE WINDOW hp_dev1

******

PROCEDURE hp_edit
PRIVATE cur_width

ON KEY LABEL F1 DO hp_mess WITH 5
SET CURSOR on

DEFINE WINDOW help_win FROM 01,06 TO 20,73 ;
                       DOUBLE
ACTIVATE WINDOW help_win

@ 00,00 GET help_mess
KEYBOARD chr(29)              &&  stuff the buffer
READ

RELEASE WINDOW help_win
SET CURSOR off

RETURN

******

PROCEDURE hp_size
PRIVATE m_key

ON KEY LABEL F1 DO hp_mess WITH 6

***  start by defining the current window

DEFINE WINDOW help_win FROM mul_row, mul_col ;
                       TO mlr_row, mlr_col ;
                       DOUBLE
ACTIVATE WINDOW help_win

DO WHILE .t.

  m_key = 0

  DO WHILE m_key = 0
    m_key = inkey()
  ENDDO

  DO CASE

    CASE m_key = 5            &&  cursor up
      mlr_row = mlr_row - 1

    CASE m_key = 24           &&  cursor down
      mlr_row = mlr_row + 1

    CASE m_key = 19           &&  cursor left
      mlr_col = mlr_col - 1

    CASE m_key = 4            &&  cursor right
      mlr_col = mlr_col + 1

    CASE m_key = 27 .or. m_key = 13   &&  exit
      EXIT

    OTHERWISE                 &&  not interested
      LOOP

  ENDCASE

  IF mlr_row = mul_row + 2  &&  too small
    ?? chr(7)
    mlr_row = mlr_row + 1
    LOOP
  ENDIF

  IF mlr_row = 25           &&  too big
    ?? chr(7)
    mlr_row = 24
    LOOP
  ENDIF

  IF mlr_col = mul_col + 7  &&  too small
    ?? chr(7)
    mlr_col = mlr_col + 1
    LOOP
  ENDIF

  IF mlr_col = 80           &&  too big
    ?? chr(7)
    mlr_col = 79
    LOOP
  ENDIF

***  now that we have all this taken care of repaint window

  DEFINE WINDOW help_win FROM mul_row, mul_col ;
                         TO mlr_row, mlr_col ;
                         DOUBLE
  ACTIVATE WINDOW help_win

ENDDO

RELEASE WINDOW help_win

RETURN

********

PROCEDURE hp_move
PRIVATE m_key

ON KEY LABEL F1 DO hp_mess WITH 7

***  start by defining the current window

DEFINE WINDOW help_win FROM mul_row, mul_col ;
                       TO mlr_row, mlr_col ;
                       DOUBLE
ACTIVATE WINDOW help_win

DO WHILE .t.
  m_key = 0

  DO WHILE m_key = 0
    m_key = inkey()
  ENDDO

  DO CASE

    CASE m_key = 5            &&  cursor up

      IF mul_row > 0          &&  we can move
        mul_row = mul_row - 1
        mlr_row = mlr_row - 1
        MOVE WINDOW help_win BY -1,0
      ELSE
        ?? chr(7)
      ENDIF

    CASE m_key = 24           &&  cursor down

      IF mlr_row < 24         &&  we can move
        mul_row = mul_row + 1
        mlr_row = mlr_row + 1
        MOVE WINDOW help_win BY 1,0
      ELSE
        ?? chr(7)
      ENDIF

    CASE m_key = 19           &&  cursor left

      IF mul_col > 0          &&  we can move
        mul_col = mul_col - 1
        mlr_col = mlr_col - 1
        MOVE WINDOW help_win BY 0,-1
      ELSE
        ?? chr(7)
      ENDIF

    CASE m_key = 4            &&  cursor right

      IF mlr_col < 79         &&  we can move
        mul_col = mul_col + 1
        mlr_col = mlr_col + 1
        MOVE WINDOW help_win BY 0,1
      ELSE
        ?? chr(7)
      ENDIF

    CASE m_key = 27 .or. m_key = 13   &&  exit
      EXIT

  ENDCASE

ENDDO

RELEASE WINDOW help_win

RETURN

********

PROCEDURE hp_mess
PARAMETERS h_mess_no
PRIVATE h_mess_no, hp_mess

***  This is the help on help program

DO CASE

  CASE h_mess_no = 1
    hp_mess = 'No help message for this situation.'

  CASE h_mess_no = 2
    hp_mess = 'Answer "Yes" if you want to create a new '+;
              'help screen.'

  CASE h_mess_no = 3
    hp_mess = 'Answer "Yes" if you want help on '+;
              'individual menu options.'

  CASE h_mess_no = 4
    hp_mess = 'Type in the number of your choice.'

  CASE h_mess_no = 5
    hp_mess = 'Type in help message that you want for ' +;
              'this situation.  Press Ctrl-End to save '+;
              'your message or the Escape key to abort.'

  CASE h_mess_no = 6
    hp_mess = 'Use the cursor keys to change the size of '+;
              'the help window.  Press Escape to return '+;
              'to the menu.'

  CASE h_mess_no = 7
    hp_mess = 'Use the cursor keys to move the help '+;
              'window around the screen.  Press Escape '+;
              'to return to the menu.'

ENDCASE

junk = poptalk(hp_mess,3)

RETURN

********

FUNCTION yesno
PARAMETERS bx_mess
PRIVATE bx_mess, num_lines, cur_clr
PRIVATE cur_curs, e_mess, i, m_col, yes_on, n_clr
PRIVATE opt_clr, yntemp, m_key, rvalue

*  Copyright (c) 1992 Performannce Dynamics Associates
*  Stripped-down version of Power Tools yesno function

rvalue = .f.

***  paint the message that is to appear at the top
***  of the dialog box.

IF len(bx_mess) <= 40         &&  if message is one line
  num_lines = 1
ELSE                          &&  if message is 2+ lines
  num_lines = mlcount(bx_mess,40)
ENDIF

***  let's do colors!

cur_clr = set('attribute')
n_clr = left(cur_clr,at(',',cur_clr)-1)
opt_clr = substr(cur_clr,at(',',cur_clr)+1)
opt_clr = left(opt_clr,at(',',opt_clr)-1)

***  don't forget to turn off the cursor

cur_curs = set('cursor') = 'ON'
SET CURSOR OFF

DEFINE WINDOW yesno FROM 9,16 ;
                    TO 14+num_lines,63;
                    DOUBLE
ACTIVATE WINDOW yesno

IF num_lines = 1
  @ 01,23-(len(bx_mess)/2) SAY bx_mess
  i = 3
ELSE
  i = 1
  DO WHILE i <= num_lines
    @ i,03 SAY memoline(bx_mess,40,i)
    i = i + 1
  ENDDO

i = i + 1                     &&  add the spacer line

ENDIF

@ i,07 SAY   '<  Yes  >'
@ i,29 SAY '<  No  >'
SAVE SCREEN TO yntemp

yes_on = .t.                  &&  starting condition
m_key = 0

DO WHILE .t.

  DO CASE

    CASE m_key = 4 .or. m_key = 19
      yes_on = .not. yes_on

    CASE m_key = 13           &&  Enter key pressed
      rvalue = yes_on
      EXIT

***  test for 'y', 'Y'

    CASE m_key =  89 .or. m_key = 121
      rvalue = .t.
      EXIT

    CASE m_key =  78 .or. m_key = 110   && 'N' or 'n'
      rvalue = .f.
      EXIT

  ENDCASE

  IF yes_on
    SET COLOR OF NORMAL TO &opt_clr
    @ i,08 SAY  '  Yes  '
  ELSE
    SET COLOR OF NORMAL TO &opt_clr
    @ i,30 SAY '  No  '
  ENDIF

  m_key = 0

  DO WHILE m_key = 0
    m_key = inkey()           &&  wait for key
  ENDDO

  RESTORE SCREEN FROM yntemp

ENDDO

RELEASE WINDOW yesno
RELEASE SCREEN yntemp

IF cur_curs                   &&  turn the cursor back on.
  SET CURSOR ON
ENDIF

IF isblank(cur_win)
  ACTIVATE SCREEN
ENDIF

RETURN(rvalue)

********

FUNCTION poptalk
PARAMETERS pass_mess, st_time
PRIVATE pass_mess, t_mess, num_lines, i 
PRIVATE c_scheme, t_mess, s_row, s_col, slr_row, slr_col

*  Copyright (c) 1992 Performance Dynamics Associates
*  Stripped-down version of Power Tools poptalk function 

t_mess = pass_mess
s_row = 10
s_col = 15

IF len(t_mess) <= 40          &&  one-line message
  s_col = s_col + 18 - int(len(t_mess)/2)
  s_col = iif(s_col+len(t_mess) > 69,69-len(t_mess),;
              s_col)
  s_row = iif(s_row>20,20,s_row)
  slr_row = s_row + 4
  slr_col = s_col + 10 + len(t_mess)
ELSE
  num_lines = mlcount(t_mess,40)
  s_col = iif(s_col > 30,30,s_col)
  s_row = iif(s_row+num_lines > 21,21-num_lines,s_row)
  slr_row = s_row + 3  + num_lines
  slr_col = s_col + 49
ENDIF

DEFINE WINDOW poptalk FROM s_row,s_col ;
                      TO slr_row,slr_col;
                      DOUBLE
ACTIVATE WINDOW poptalk

IF len(t_mess) <= 40
  @ 1,4 SAY t_mess
ELSE
  i = 1

  DO WHILE i <= num_lines
    @ i,4 SAY  memoline(t_mess,40,i)
    i = i + 1
  ENDDO

ENDIF

junk = inkey(st_time)
RELEASE WINDOW poptalk

IF isblank(cur_win)
  ACTIVATE SCREEN
ENDIF

RETURN('')

********

FUNCTION memo_pop
PARAMETERS sul_row, sul_col, slr_row, slr_col, m_name
PRIVATE sul_row, sul_col, slr_row, slr_col, m_name
PRIVATE m_width, m_height, m_mark, m_max
PRIVATE cur_curs, cur_wid, i, m_key, m_bord

*  Copyright (c) 1992 Performance Dynamics Associates
*  Stripped-down version of Power Tools memo_pop function

m_width = slr_col - sul_col - 3
m_height = slr_row - sul_row - 1

cur_wid = set('memowidth')
SET memowidth to m_width

cur_curs = set('cursor') = 'ON'
SET CURSOR OFF

m_max = memlines(&m_name)
m_mark = m_height

DEFINE WINDOW memo_temp FROM sul_row,sul_col ;
                        TO slr_row,slr_col ;
                        DOUBLE
ACTIVATE WINDOW memo_temp

DO memopop1

DO WHILE .t.
  m_key = 0

  DO WHILE m_key = 0
    m_key = inkey()
  ENDDO

  IF m_key = 27 .or. m_key = 23
    EXIT
  ENDIF

  DO CASE

    CASE m_key = 24           &&  cursor down

      IF m_mark < m_max
        m_mark = m_mark + 1
        ? ' ' + mline(&m_name,m_mark)
     ELSE
        ?? chr(7)
      ENDIF

    CASE m_key = 5            &&  cursor up

      IF m_mark # m_height
        m_mark = max(m_mark-1, m_height)
        DO memopop1
      ELSE
        ?? chr(7)
      ENDIF

    CASE m_key = 18           &&  page up

      IF m_mark > m_height
        m_mark = max(m_height, m_mark-m_height+1)
        DO memopop1
      ELSE
        ?? chr(7)
      ENDIF

    CASE m_key = 3            &&  page down

      IF m_mark # m_max
        m_mark = min(m_max, m_mark+m_height-1)
        DO memopop1
      ELSE
        ?? chr(7)
      ENDIF

    CASE m_key = 26           &&  home key
      m_mark = m_height
      DO memopop1

    CASE m_key = 2            &&  end key
      m_mark = m_max
      DO memopop1

  ENDCASE

ENDDO

RELEASE WINDOW memo_temp
SET MEMOWIDTH TO cur_wid

IF cur_curs
  SET CURSOR ON
ENDIF

IF isblank(cur_win)
  ACTIVATE SCREEN
ENDIF

RETURN(m_max)

********

PROCEDURE memopop1

***  paint the window

CLEAR
i = 1

DO WHILE i <= m_height
@ i-1,1 say mline(&m_name,m_mark-m_height+i)
  i = i + 1
ENDDO

RETURN

********

FUNCTION mlcount
PARAMETERS m_string, line_len
PRIVATE m_string, work_str, line_len, num_lines, i

*  Copyright (c) 1982 Performance Dynamics Associates
*  Stripped-down version of Power Tools mlcount function

num_lines = 1
work_str = m_string

DO while len(work_str) > line_len

  i = line_len + 1           &&  starting position for trim

  DO WHILE substr(work_str,i,1) # chr(32)  &&  find space
    i = i - 1
  ENDDO
  
  work_str = ltrim(substr(work_str,i))   &&  trim string 
  num_lines = num_lines + 1

ENDDO

RETURN(num_lines)

********

FUNCTION memoline
PARAMETERS pstring, line_len, line_no
PRIVATE pstring, rvalue, line_len, line_no, line_count, i

*  Copyright (c) 1992 Performance Dynamics Associates
*  Stripped-down version of Power Tools memoline program

i = line_len + 1           &&  starting position for trim
line_count = 1
rvalue = pstring

DO WHILE line_count < line_no  &&  trimming the string to 
  i = line_len + 1             &&  the specified line number

  DO while substr(rvalue,i,1) # chr(32)
    i = i - 1
  ENDDO

  rvalue = ltrim(substr(rvalue,i))
  line_count = line_count + 1

ENDDO

***  we are now at the start of the desired line!

IF len(rvalue) > line_len     &&  if string needs trimming
  i = line_len + 1            &&  start trimming

  DO while substr(rvalue,i,1) # chr(32)
    i = i - 1
  ENDDO

  rvalue = substr(rvalue,1,i) &&  trimmed string
ENDIF

RETURN(rvalue)

********
